package DNDGui;

/*
 * DNDForm.java
 *
 * Created on 18 de noviembre de 2008, 11:26
 */


import DNDCore.Loader;
import DNDCore.Diagram;
import DNDCore.Workspace;
import DNDCore.Tool;
import DNDCore.DiagramVertice;
import DNDCore.DND;
import DNDCore.DiagramObject;
import DNDPlugins.basic.DiagramCircle;
import DNDPlugins.basic.DiagramImage;
import DNDPlugins.basic.DiagramRectangle;
import DNDPlugins.basic.DiagramSmartTest;
import DNDPlugins.basic.DiagramTriangle;
import java.awt.Point;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

/**
 *
 * @author  DND Team
 */
public class EditorMain extends javax.swing.JFrame implements Loader {
    private DND dnd;
//JOptionPane.
    /** Creates new form NewJFrame */
    public EditorMain(DND dnd) {
        initComponents();
        
        this.dnd = dnd;
        fillTree();
        loadPlugins();
    }

    public void loadPlugins()
    {
        
    }

    private void fillTree() {
        DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode("Componentes");
        TreeModel treeModel = new DefaultTreeModel(rootNode);
        DefaultMutableTreeNode basicos = new DefaultMutableTreeNode("Basicos");
        rootNode.add(basicos);
        
        DefaultMutableTreeNode leaf = new DefaultMutableTreeNode(DiagramCircle.class);
        basicos.add(leaf);
        
        leaf = new DefaultMutableTreeNode(DiagramVertice.class);
        basicos.add(leaf);
        
        leaf = new DefaultMutableTreeNode(DiagramRectangle.class);
        basicos.add(leaf);
        
        leaf = new DefaultMutableTreeNode(DiagramTriangle.class);
        basicos.add(leaf);
        
        leaf = new DefaultMutableTreeNode(DiagramImage.class);
        basicos.add(leaf);
        
        pluginsTree.setModel(treeModel);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        openChooser = new javax.swing.JFileChooser();
        saveChooser = new javax.swing.JFileChooser();
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        zoomSlider = new javax.swing.JSlider();
        jLabel1 = new javax.swing.JLabel();
        selectButton = new javax.swing.JButton();
        handButton = new javax.swing.JButton();
        addDiagramButton = new javax.swing.JButton();
        closeDiagramButton = new javax.swing.JButton();
        undoButton = new javax.swing.JButton();
        redoButton = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        zoomTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        pluginsTree = new javax.swing.JTree();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jMenuBar5 = new javax.swing.JMenuBar();
        jMenu9 = new javax.swing.JMenu();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem6 = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JSeparator();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenu10 = new javax.swing.JMenu();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("DND");

        jSplitPane1.setBackground(new java.awt.Color(102, 102, 102));
        jSplitPane1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jSplitPane1.setDividerLocation(150);
        jSplitPane1.setDividerSize(3);
        jSplitPane1.setMinimumSize(new java.awt.Dimension(150, 300));

        zoomSlider.setForeground(new java.awt.Color(153, 153, 153));
        zoomSlider.setMaximum(400);
        zoomSlider.setMinimum(10);
        zoomSlider.setToolTipText("Cambia factor de aumento");
        zoomSlider.setValue(100);
        zoomSlider.setEnabled(false);
        zoomSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                zoomSliderStateChanged(evt);
            }
        });

        jLabel1.setText("Zoom");

        selectButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Data/seleccion.png"))); // NOI18N
        selectButton.setContentAreaFilled(false);
        selectButton.setName("seleccionar"); // NOI18N
        selectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectButtonActionPerformed(evt);
            }
        });

        handButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Data/mano.png"))); // NOI18N
        handButton.setToolTipText("Mano");
        handButton.setContentAreaFilled(false);
        handButton.setName("Selección Multiple"); // NOI18N
        handButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                handButtonActionPerformed(evt);
            }
        });

        addDiagramButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Data/Knob Add.png"))); // NOI18N
        addDiagramButton.setToolTipText("Crear nuevo diagrama");
        addDiagramButton.setContentAreaFilled(false);
        addDiagramButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addDiagramButtonActionPerformed(evt);
            }
        });

        closeDiagramButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Data/Knob Remove.png"))); // NOI18N
        closeDiagramButton.setToolTipText("Cerrar diagrama actual");
        closeDiagramButton.setContentAreaFilled(false);
        closeDiagramButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeDiagramButtonActionPerformed(evt);
            }
        });

        undoButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Data/Knob Snapback.png"))); // NOI18N
        undoButton.setToolTipText("Deshacer");
        undoButton.setContentAreaFilled(false);
        undoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                undoButtonActionPerformed(evt);
            }
        });

        redoButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Data/Knob Snapforward.png"))); // NOI18N
        redoButton.setToolTipText("Rehacer");
        redoButton.setContentAreaFilled(false);
        redoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                redoButtonActionPerformed(evt);
            }
        });

        zoomTextField.setVisible(false);
        zoomTextField.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        zoomTextField.setText("100");
        zoomTextField.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        zoomTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zoomTextFieldActionPerformed(evt);
            }
        });

        jLabel2.setVisible(false);
        jLabel2.setText("%");
        jLabel2.setEnabled(false);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(selectButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(handButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(26, 26, 26)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(undoButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(addDiagramButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(29, 29, 29)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(closeDiagramButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(redoButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(zoomSlider, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(58, 58, 58)
                        .addComponent(jLabel1))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(47, 47, 47)
                        .addComponent(zoomTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(4, 4, 4)
                        .addComponent(jLabel2)))
                .addGap(14, 14, 14))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(addDiagramButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(closeDiagramButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(undoButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(redoButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(7, 7, 7)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 13, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(selectButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(handButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(zoomSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(zoomTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addGap(101, 101, 101))
        );

        zoomSlider.getAccessibleContext().setAccessibleName("Zoom factor");
        zoomSlider.getAccessibleContext().setAccessibleDescription("100%");

        pluginsTree.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                pluginsTreeMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(pluginsTree);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 213, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
            .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 225, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jSplitPane1.setLeftComponent(jPanel1);

        jTabbedPane1.setBackground(new java.awt.Color(153, 153, 153));
        jTabbedPane1.setForeground(new java.awt.Color(255, 255, 255));
        jTabbedPane1.setDoubleBuffered(true);
        jTabbedPane1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jTabbedPane1StateChanged(evt);
            }
        });
        jSplitPane1.setRightComponent(jTabbedPane1);

        jMenu9.setText("DND");

        jMenuItem4.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.ALT_MASK));
        jMenuItem4.setText("Abrir");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMenu9.add(jMenuItem4);

        jMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_G, java.awt.event.InputEvent.ALT_MASK));
        jMenuItem2.setText("Guardar");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu9.add(jMenuItem2);

        jMenuItem6.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.ALT_MASK));
        jMenuItem6.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Data/texto.png"))); // NOI18N
        jMenuItem6.setText("Extensiones");
        jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem6ActionPerformed(evt);
            }
        });
        jMenu9.add(jMenuItem6);
        jMenu9.add(jSeparator2);

        jMenu1.setText("Exportar a");

        jMenuItem1.setText("Imagen PNG");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenu9.add(jMenu1);

        jMenuItem3.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_I, java.awt.event.InputEvent.ALT_MASK));
        jMenuItem3.setText("Imprimir");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu9.add(jMenuItem3);
        jMenu9.add(jSeparator3);

        jMenuItem5.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.ALT_MASK));
        jMenuItem5.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Data/Knob Remove Red.png"))); // NOI18N
        jMenuItem5.setText("Salir");
        jMenu9.add(jMenuItem5);

        jMenuBar5.add(jMenu9);

        jMenu10.setText("Edición");
        jMenuBar5.add(jMenu10);

        setJMenuBar(jMenuBar5);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 629, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 446, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void addDiagramButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addDiagramButtonActionPerformed
        Workspace workspace = new Workspace(new Diagram());
        jTabbedPane1.add("Sin nombre " + ++projectCount, workspace);
        
        zoomSlider.setEnabled(true);
        zoomTextField.setVisible(true);
        jLabel2.setVisible(true);
}//GEN-LAST:event_addDiagramButtonActionPerformed

    private void closeDiagramButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeDiagramButtonActionPerformed
        Workspace workspace = getCurrentWorkspace();
        
        if (workspace == null) {
            JOptionPane.showMessageDialog(this, "No hay hoja de trabajo", "Hey!", JOptionPane.ERROR_MESSAGE);
        } else {
            int ret = JOptionPane.showConfirmDialog(this, "¿Desea guardar la hoja de trabajo?", "Que no se te olvide!", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
            if (ret == JOptionPane.YES_OPTION) {
                saveChooser.showSaveDialog(this);

                File diagramFile = saveChooser.getSelectedFile();
                Diagram currentDiagram = workspace.getDNDiagram();
                try {
                    currentDiagram.saveToFile(diagramFile);
                } catch (FileNotFoundException ex) {
                    Logger.getLogger(EditorMain.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IOException ex) {
                    Logger.getLogger(EditorMain.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
            
            if(ret == JOptionPane.YES_OPTION || ret == JOptionPane.NO_OPTION) {
                jTabbedPane1.removeTabAt(jTabbedPane1.getSelectedIndex());
                Runtime.getRuntime().gc();
            }
                
        }
}//GEN-LAST:event_closeDiagramButtonActionPerformed

    private void handButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_handButtonActionPerformed
    Workspace workspace = getCurrentWorkspace();
    workspace.setTool(Tool.HAND);
}//GEN-LAST:event_handButtonActionPerformed

    private void undoButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_undoButtonActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_undoButtonActionPerformed

    private void redoButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_redoButtonActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_redoButtonActionPerformed

    public Workspace getCurrentWorkspace()
    {
        return (Workspace)jTabbedPane1.getSelectedComponent();
    }
    
    private void zoomSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_zoomSliderStateChanged
        Workspace workspace = getCurrentWorkspace();
        workspace.setZoom(zoomSlider.getValue()/100.0);
        zoomTextField.setText(""+zoomSlider.getValue());
    }//GEN-LAST:event_zoomSliderStateChanged

private void selectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectButtonActionPerformed
    Workspace workspace = getCurrentWorkspace();
    workspace.setTool(Tool.SELECT);
}//GEN-LAST:event_selectButtonActionPerformed

private void zoomTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomTextFieldActionPerformed
    Workspace workspace = getCurrentWorkspace();
    int v = Integer.parseInt(zoomTextField.getText());
    if(v < 0)
        v = 10;
    
    if(v > 400)
        v = 400;
    
    zoomSlider.setValue(v);
    workspace.setZoom(v/100.0);
}//GEN-LAST:event_zoomTextFieldActionPerformed

private void jTabbedPane1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jTabbedPane1StateChanged
    Workspace workspace = getCurrentWorkspace();
    if(workspace == null) {
        zoomSlider.setEnabled(false);
        zoomTextField.setVisible(false);
        jLabel2.setVisible(false);
    } else {
        int zoom = (int)(100*workspace.getDNDiagram().getCanvas().getZoom());
        zoomSlider.setValue(zoom);
        zoomTextField.setText(""+zoom);
    }
}//GEN-LAST:event_jTabbedPane1StateChanged

private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
    Workspace workspace = getCurrentWorkspace();
    if(workspace != null)
        workspace.getWorkarea().setRequestShot(true);
    workspace.updateWorkspace();
}//GEN-LAST:event_jMenuItem1ActionPerformed

private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
   saveChooser.showSaveDialog(this);
   
    File diagramFile = saveChooser.getSelectedFile();
    Diagram currentDiagram = getCurrentWorkspace().getDNDiagram();
    try {
        currentDiagram.saveToFile(diagramFile);
    } catch (FileNotFoundException ex) {
        Logger.getLogger(EditorMain.class.getName()).log(Level.SEVERE, null, ex);
    } catch (IOException ex) {
        Logger.getLogger(EditorMain.class.getName()).log(Level.SEVERE, null, ex);
    }
        
}//GEN-LAST:event_jMenuItem2ActionPerformed

private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
    PluginManager plugin = PluginManager.getInstance();
    
    plugin.setVisible(true);
}//GEN-LAST:event_jMenuItem6ActionPerformed

private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
    openChooser.showOpenDialog(this);
    File diagramFile = openChooser.getSelectedFile();
    Diagram savedDiagram = null;
    try {
        savedDiagram = Diagram.createDiagramFromFile(diagramFile);
    } catch (FileNotFoundException ex) {
        System.out.println("ERROR");
        Logger.getLogger(EditorMain.class.getName()).log(Level.SEVERE, null, ex);
    }
    
    if(savedDiagram != null) {
        jTabbedPane1.add(diagramFile.getName(), new Workspace(savedDiagram));//GEN-LAST:event_jMenuItem4ActionPerformed
    }
}

        private void pluginsTreeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_pluginsTreeMouseClicked
            TreePath treePath = pluginsTree.getSelectionPath();
            
            if(treePath != null) { 
                DefaultMutableTreeNode node = (DefaultMutableTreeNode) treePath.getLastPathComponent();
                if (node.isLeaf()) {
                try {

                    Class componentClass = (Class) node.getUserObject();
                    System.out.println(componentClass.getName());

                    Method ccMethod = componentClass.getDeclaredMethod("createComponent", null);
                    DiagramObject[] diagramObject = (DiagramObject[]) ccMethod.invoke(null);
                    Workspace workspace = getCurrentWorkspace();
                    if (workspace != null) {
                        for(DiagramObject o : diagramObject)
                        workspace.addElement(o);
                    }
                } catch (IllegalAccessException ex) {
                    Logger.getLogger(EditorMain.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IllegalArgumentException ex) {
                    Logger.getLogger(EditorMain.class.getName()).log(Level.SEVERE, null, ex);
                } catch (InvocationTargetException ex) {
                    Logger.getLogger(EditorMain.class.getName()).log(Level.SEVERE, null, ex);
                } catch (NoSuchMethodException ex) {
                    Logger.getLogger(EditorMain.class.getName()).log(Level.SEVERE, null, ex);
                } catch (SecurityException ex) {
                    Logger.getLogger(EditorMain.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }//GEN-LAST:event_pluginsTreeMouseClicked
        }
            private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
                    Workspace workspace = getCurrentWorkspace();
    workspace.getWorkarea().setRequestShot(true);
   workspace.getWorkarea().setPrint(true);
    workspace.updateWorkspace();
            }//GEN-LAST:event_jMenuItem3ActionPerformed
        

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addDiagramButton;
    private javax.swing.JButton closeDiagramButton;
    private javax.swing.JButton handButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu10;
    private javax.swing.JMenu jMenu9;
    private javax.swing.JMenuBar jMenuBar5;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JFileChooser openChooser;
    private javax.swing.JTree pluginsTree;
    private javax.swing.JButton redoButton;
    private javax.swing.JFileChooser saveChooser;
    private javax.swing.JButton selectButton;
    private javax.swing.JButton undoButton;
    private javax.swing.JSlider zoomSlider;
    private javax.swing.JTextField zoomTextField;
    // End of variables declaration//GEN-END:variables
    private int projectCount;
}
